Subject: bug#49424: 27.2; Misdocumented default initialisation file

From: Stephen Berman <[email-masked]>
Date: Wed, 07 Jul 2021 16:11:32 +0200

On Wed, 07 Jul 2021 15:08:21 +0200 Robert Pluim <[email-masked]> wrote:

>>>>>> On Thu, 08 Jul 2021 00:24:22 +1200, Phil Sainty <[email-masked]> said:
>
>     Phil> On 2021-07-07 21:17, Robert Pluim wrote:
>     >> If nothing exists, Emacs will create ~/.emacs.d, and use ~/.emacs as
>     >> as the init file. We can change that to use ~/.emacs.d/init.el if we
>     >> want, people who already have init files will not be affected.
>     >> </bold prediction of there being no consequences>
>
>     Phil> I know of people who have ~/.emacs.d under version control (used on
>     Phil> multiple machines), and on some machines additionally have a ~/.emacs
>     Phil> file for config which is local to that particular machine.  The .emacs
>     Phil> file simply loads the init.el file.
>
> Thatʼs a different branch of the startup logic :-)
>
> If we change things so that ~/.emacs.d/init.el is used only if there
> is no .emacs, they would not be affected. I think this is already
> the case, but I may be misremembering
>
>     Phil> There are other ways of achieving the same thing; but I thought this
>     Phil> one was quite a neat approach when I heard it.
>
>     Phil> In other words, FYI some people's configs are definitely reliant on
>     Phil> the current precedence order.
>
>     Phil> In any case, while the sequence *could* be changed for those two
>     Phil> files, I don't think there's any notable benefit to doing so?  Even
>     Phil> ignoring cases like the one above, that change would undoubtedly
>     Phil> cause some confusion for no good reason.
>
> Iʼm not proposing changing the sequence, only what happens in the case
> where there are no init files at all. It would eliminate the 'why is
> emacs creating .emacs.d but then not using it' confusion.

One thing I find useful about the current way is that I can use ~/.emacs
to carry out tests requiring (or facilitated by having) an init file,
without having to move or otherwise disable my actual init file
~/.emacs.d/init.el.  That benefit would be lost if the priority was
changed (or it would require making ~/.emacs the real init file and
using ~/.emacs.d/init.el for testing, which seems less appealing).

Steve Berman